diff --git a/src/backend/optimizer/util/predtest.c b/src/backend/optimizer/util/predtest.c
index cba6608ce2..6d6c0faf4f 100644
--- a/src/backend/optimizer/util/predtest.c
+++ b/src/backend/optimizer/util/predtest.c
@@ -1339,6 +1339,12 @@ clause_is_strict_for(Node *clause, Node *subexpr)
 		}
 		return false;
 	}
+	if (IsA(clause, ScalarArrayOpExpr))
+	{
+		ScalarArrayOpExpr *saop = (ScalarArrayOpExpr *) clause;
+		if (op_strict(saop->opno))
+			return true;
+	}
 	if (is_funcclause(clause) &&
 		func_strict(((FuncExpr *) clause)->funcid))
 	{
